/*******************************************************************************
 * FoxSpecialMove_MeleeLungeBlind generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxSpecialMove_MeleeLungeBlind extends FoxSpecialMove
    native(SpecialMoves);

var transient Vector StopLocation;
var transient Vector StartLocation;
var const float DamageRadius;

protected function bool InternalCanDoSpecialMove()
{
    return !PawnOwner.IsDoingSpecialMove(1) && PawnOwner.Physics != 2;
    //return ReturnValue;    
}

function bool CanChainMove(FoxTypes.ESpecialMove NextMove)
{
    return true;
    //return ReturnValue;    
}

simulated function StartSpecialMove()
{
    StartLocation = PawnOwner.Location;
    StopLocation = ChooseLungeEndPoint(PawnOwner.AttachClass_RightHand.default.WeaponClass.default.MeleeLungeRange);
    PawnOwner.Acceleration = StopLocation - PawnOwner.Location;
    PawnOwner.Velocity = StopLocation - PawnOwner.Location;
    PawnOwner.bForceMaxAccel = true;
    PawnOwner.ToggleCrouch(false);
    // End:0x188
    if(PawnOwner.Role == ROLE_Authority)
    {
        DoDamage();
    }
    super.StartSpecialMove();
    //return;    
}

simulated function CleanUpSpecialMove()
{
    // End:0x37
    if(PawnOwner != none)
    {
        PawnOwner.ClearSpecialMoveTimer(SpecialMoveType);
    }
    PawnOwner.bForceMaxAccel = false;
    StopLocation = vect(0.0, 0.0, 0.0);
    super.CleanUpSpecialMove();
    //return;    
}

simulated function DoDamage()
{
    local array<Actor> ActorsInPath;
    local Actor victimActor;
    local int I;
    local ImpactInfo Info;

    // End:0x1DA
    if(PawnOwner.Role == ROLE_Authority)
    {
        ActorsInPath = GetActorsInPath();
        I = 0;
        J0x48:
        // End:0x1DA [Loop If]
        if(I < ActorsInPath.Length)
        {
            victimActor = ActorsInPath[I];
            Info.HitActor = victimActor;
            Info.HitLocation = victimActor.Location;
            Info.HitNormal = StartLocation - Info.HitLocation;
            Info.RayDir = StartLocation - Info.HitLocation;
            Info.StartTrace = StartLocation;
            PawnOwner.MyFoxWeapon.ProcessInstantHit(2, Info, 1);
            ++ I;
            // [Loop Continue]
            goto J0x48;
        }
    }
    //return;    
}

simulated event ReachedDestination()
{
    PawnOwner.bForceMaxAccel = false;
    PawnOwner.Velocity = vect(0.0, 0.0, 0.0);
    PawnOwner.Acceleration = vect(0.0, 0.0, 0.0);
    PawnOwner.ClearSpecialMoveTimer(21);
    PawnOwner.SpecialMoveTimerFinished();
    //return;    
}

// Export UFoxSpecialMove_MeleeLungeBlind::execChooseLungeEndPoint(FFrame&, void* const)
native function Vector ChooseLungeEndPoint(float LungeRange);

// Export UFoxSpecialMove_MeleeLungeBlind::execGetActorsInPath(FFrame&, void* const)
native function array<Actor> GetActorsInPath();

defaultproperties
{
    DamageRadius=96.0
    SpeedModifier=6.0
    bOverrideSpeedModifier=true
    bCanFireWeapon=false
    bCanCrouchInState=false
    bLockPawnRotation=true
    bDisableMovement=true
}